<#
Written by: Stephen W Thomas
Email: me@biztalkguru.com
Twitter: @stephenwthomas
Community Site: www.BIzTalkGurus.com
Personal Site: www.BizTalkGuru.com

Content provided as-is.  Use at your own risk.  Charges may/will apply when creating VMs inside Windows Azure. 

This script will create one SQL Enterprise and two BizTalk Enterprise servers
It will join the three to the domain and disable the firewall
For SQL, it will add the Domain Admin as a SQL Sys Admin

WARNING - this script was only tested with a subscription that did not have any existing Virtual Networks.  It may fail if any VNets already exist.  

Change Log:
1.0 (6/2/2014) - Initial release (Tested with May 2014 PowerShell Commands - older versions may not work)
1.1 (6/10/2014) - Added support for per-server sizing
#>

"Start - Create SQL"

Set-AzureSubscription -SubscriptionName $subscriptionName -CurrentStorageAccount $defaultStorageAccount -ErrorAction SilentlyContinue
Select-AzureSubscription -SubscriptionName $subscriptionName

# Set the DNS IP once the DC is setup and configured
$myDNS = New-AzureDNS -Name $dnsName -IPAddress $dnsIP

# SQL 01 VM Configuration
$MyVM1 = New-AzureVMConfig -name $vmnameSQL01 -InstanceSize $sizeSQL -ImageName $imageSQLEnt `
    | Add-AzureProvisioningConfig -WindowsDomain -AdminUsername $adminUserName  -Password $password -Domain $domainNamePreFix -DomainPassword $password -DomainUserName $domainAdminUserName -JoinDomain $domainName `
    | Set-AzureSubnet -SubnetNames $subNetName `
    | Set-AzureStaticVNetIP -IPAddress 10.0.0.5

New-AzureVM -ServiceName $vmnameSQL01 -AffinityGroup $affinityGroup -VMs $MyVM1 -DnsSettings $myDNS -VNetName $virtualNetwork -WaitForBoot -ErrorAction Stop

"End - Create SQL"
"Start - Create BTS01"

# BizTalk 01 VM Configuration
$MyVM2 = New-AzureVMConfig -name $vmnameBTS01 -InstanceSize $sizeBTS -ImageName $imageBTSEnt `
    | Add-AzureProvisioningConfig -WindowsDomain -AdminUsername $adminUserName  -Password $password -Domain $domainNamePreFix -DomainPassword $password -DomainUserName $domainAdminUserName -JoinDomain $domainName `
    | Set-AzureSubnet -SubnetNames $subNetName  `
    | Set-AzureStaticVNetIP -IPAddress 10.0.0.6

New-AzureVM -ServiceName $vmnameBTS01 -AffinityGroup $affinityGroup -VMs $MyVM2 -DnsSettings $myDNS -VNetName $virtualNetwork -WaitForBoot -ErrorAction Stop

"End - Create BTS01"
"Start - Create BTS02"

# BizTalk 02 VM Configuration
$MyVM3 = New-AzureVMConfig -name $vmnameBTS02 -InstanceSize $sizeBTS -ImageName $imageBTSEnt `
    | Add-AzureProvisioningConfig -WindowsDomain -AdminUsername $adminUserName  -Password $password -Domain $domainNamePreFix -DomainPassword $password -DomainUserName $domainAdminUserName -JoinDomain $domainName `
    | Set-AzureSubnet -SubnetNames $subNetName `
    | Set-AzureStaticVNetIP -IPAddress 10.0.0.7

New-AzureVM -ServiceName $vmnameBTS02 -AffinityGroup $affinityGroup -VMs $MyVM3 -DnsSettings $myDNS -VNetName $virtualNetwork -WaitForBoot -ErrorAction Stop

"End - Create BTS02"
