﻿<#
Written by: Stephen W Thomas
Email: me@biztalkguru.com
Twitter: @stephenwthomas
Community Site: www.BIzTalkGurus.com
Personal Site: www.BizTalkGuru.com

Content provided as-is.  Use at your own risk.  Charges may/will apply when creating VMs inside Windows Azure. 

This is the Master Script.  Run from an elevated command promote.  Ensure all updates are make to variables.ps1 beforehand.
Also ensure your environment is correctly working with Azure.  I test with Get-AzureLocation.  It should return values.

Change Log:
1.0 (6/2/2014) - Initial release (Tested with May 2014 PowerShell Commands - older versions may not work)
#>

# This needs to be set if running from and IDE otherwise the script will determine the correct path
$pathForIDERun = "D:\Data\AzureStuff\Powershell\BuildBizTalkDomain"

cls

$IsAdmin = ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator") 

if(($IsAdmin) -eq $false)
{
    Write-Error "Must run elevated PowerShell to install WinRM certificates used for Remote PowerShell."
	return
}

$startTime = get-date
"$startTime"

"Start - Script Path"
if($MyInvocation.MyCommand.Path -eq $null) { $pathName = $pathForIDERun } else {$pathName = Split-Path $MyInvocation.MyCommand.Path -ErrorAction SilentlyContinue}
"Script Path is " + $pathName
"End - Script Path"

"Start - Load"
. $pathName\variables.ps1
"End - Load"

"Start - Ceating Network"
. $pathName\00_Create_Network.ps1
"End - Creating Network"

"Start - Creating PDC"
. $pathName\01_Create_PDC.ps1
"End - Creating PDC"

# Give it a few minutes or so - things in Azure IaaS sometimes need to settle a bit
"Sleeping for 90 seconds to let things in Azure IaaS settle"
Start-Sleep -s 90

"Start - Creating SQL and BizTalks"
. $pathName\02_Create_Servers.ps1
"End - Creating SQL and BizTalks"

# Give it a few minutes or so - things in Azure IaaS sometimes need to settle a bit
"Sleeping for 240 seconds to let things in Azure IaaS settle"
Start-Sleep -s 240

"Start - Configure servers" # This script will try to configure BizTalk using the settings provided.  
. $pathName\03_Configure_Servers_RemoteProp.ps1
"Endt - Configure servers"

# Give it a few minutes or so - things in Azure IaaS sometimes need to settle a bit
"Sleeping for 60 seconds to let things in Azure IaaS settle"
Start-Sleep -s 60

# Only needed if Auto Configure is enabled
# To enable Auto Configure the updated BizTalk Provisioning tools are needed from a Azure BizTalk 2013 Dev VM
if($installBizTalkProv -eq "true")
{
    "Start - Configure servers" # This script will try to configure BizTalk using the settings provided.  
    . $pathName\04_Configure_Servers_LaunchRDP.ps1
    "Endt - Configure servers"
}

"Start - Get RDP Files"
. $pathName\05_RemoteDesktop.ps1
"Endt - Get RDP Files"

$endTime = get-date
"Script run time " + ($endTime - $startTime)
"You can login to each server with the Domain Admin account: $domainNamePreFix\$domainAdminUserName and Password: $password"