<#
Written by: Stephen W Thomas
Email: me@biztalkguru.com
Twitter: @stephenwthomas
Community Site: www.BIzTalkGurus.com
Personal Site: www.BizTalkGuru.com

Content provided as-is.  Use at your own risk.  Charges may/will apply when creating VMs inside Windows Azure. 

This script is the main variable script for the entire process.  Charges should only be needed in this script.  
Look for the items at top marked as Update.  Only 3 values are required to be changed.  
Currently, Im hosting the Helper files on my storage account.  
If you run into errors with storage account downloads you make need to host them yourself and update the value for $workingStorageAccount.
If you are running the start, stop, or remove scripts ensure the baseVMName is set correctly.

Change Log:
1.0 (6/2/2014) - Initial release (Tested with May 2014 PowerShell Commands - older versions may not work)
1.1 (6/10/2014) - Added support for per-server sizing, VNet configuration
#>

# MUST UPDATE - BASE Name
$baseVMName = 'abcd1234'                        # UPDATE - Must be Globally Unique. This value must be 8 characters or less and all lower case. I usually use initials and numbers.

# MUST UPDATE - Subscription Details 
$subscriptionName = '<subscription name>'       # UPDATE - From publishing file

# Storage Account Details - This is the location of the Helper files used by the scripts.  Only needed if any Flag below is set to true
$workStorgeAccount = '<storage account used for auto config>'   # OPTIONAL UPDATE - Update with the storage location of the Helper Files.  Needs to have public access.  Example: https://<storage name>.blob.core.windows.net/<container>
$setupDir = "C:\BizTalkGurus"                   # OPTIONAL UPDATE - Used for files on the remote computer running the script and remove BizTalk, only used when a flag below is true
$basePathToScripts = '<path to these files>'    # OPTIONAL UPDATE - this is used if you run the scripts through an IDE not a Command Windows

# Flags
$installCU2 = 'false'                           # OPTIONAL UPDATE - Set to 'true' - Must upload BizTalk CU2 exe to the root of the Storage Account above
$installClassicShell = 'false'                  # OPTIONAL UPDATE - Set to 'true' - Must upload classic shell exe to the root of the Storage Account above
$installBizTalkProv = 'false'                   # OPTIONAL UPDATE - Set to 'true' - Must upload 5 files from BizTalk 2013 Dev box to the root of the Storage Account above

# Default Storage account
$defaultStorageAccount = $baseVMName + "store"

# Affinity Group Details
$affinityGroup = "$baseVMName-ag"
$dataCenter = 'West US'                         # From Get-AzureLocation

# VM Details
$adminUserName = 'ladmin'                       # OPTIONAL UPDATE
$password = 'Biztalk01'                         # OPTIONAL UPDATE
$sizePDC = 'Medium'                             # OPTIONAL UPDATE for the Domain Controller
$sizeSQL = 'Medium'                             # OPTIONAL UPDATE for SQL Server
$sizeBTS = 'Medium'                             # OPTIONAL UPDATE for the BizTalk Servers

$virtualNetwork = "$baseVMName-vnet"            # OPTIONAL UPDATE
$subNetName = 'App'                             # OPTIONAL UPDATE
$virtualNetworkConfig = "$pathName\Configs"     # OPTIONAL UPDATE
$virtualNetworkDNSName = 'Google'               # OPTIONAL UPDATE
$virtualNetworkDNSIP = '8.8.8.8'                # OPTIONAL UPDATE

# Domain Details
$domainName = 'corp.biztalkgurus.com'
$domainNamePreFix = 'corp'
$domainAdminUserName = 'dadmin'

# DNS Details
$dnsName = 'biztalkdns'
$dnsLoopBackIP = '127.0.0.1'
$dnsIP = '10.0.0.4'  # This is the IP of the PDC.  I'd not change this.

# Host Names of the 2 hosts auto-created by the deployment process
# To add more hosts the MultiConfig file in the storage account needs to be changed
$hostName1 = 'TrackingHost'                    # OPTIONAL UPDATE - Host1 is set for tracking
$hostName2 = 'ReceiveHost'                     # OPTIONAL UPDATE
$hostName3 = 'SendHost'                        # OPTIONAL UPDATE
$hostName4 = 'ProcessingHost'                  # OPTIONAL UPDATE

# Image Names from Get-AzureVMImage
$imageWindows = 'bd507d3a70934695bc2128e3e5a255ba__RightImage-Windows-2012-x64-v13.5'
$imageSQLEnt = 'fb83b3509582419d99629ce476bcb5c8__Microsoft-SQL-Server-2008R2SP2-Enterprise-CY13SU04-SQL2008-SP2-10.50.4021.0'
$imageSQL12Ent = 'fb83b3509582419d99629ce476bcb5c8__SQL-Server-2012-SP1-11.0.3430.0-Enterprise-ENU-Win2012-cy14su05'
$imageBTSEnt = '2cdc6229df6344129ee553dd3499f0d3__BizTalk-Server-2013-Enterprise'

# Set all the VM Name
$vmnamePDC = "$baseVMName-pdc"
$vmnameSQL01 = "$baseVMName-sql01"
$vmnameBTS01 = "$baseVMName-biz01"
$vmnameBTS02 = "$baseVMName-biz02"

# From http://michaelwasham.com/2013/04/16/windows-azure-powershell-updates-for-iaas-ga/
# Updated with http://gallery.technet.microsoft.com/scriptcenter/Configures-Secure-Remote-b137f2fe
# To Automate Remote Powershell
function InstallWinRMCert($serviceName, $vmname)
{	
    Write-Host "Installing WinRM Certificate for remote access: $serviceName $vmname"
	$WinRMCert = (Get-AzureVM -ServiceName $serviceName -Name $vmname | select -ExpandProperty vm).DefaultWinRMCertificateThumbprint
	$AzureX509cert = Get-AzureCertificate -ServiceName $serviceName -Thumbprint $WinRMCert -ThumbprintAlgorithm sha1

	$certTempFile = [IO.Path]::GetTempFileName()
	$AzureX509cert.Data | Out-File $certTempFile

	# Target The Cert That Needs To Be Imported
	$CertToImport = New-Object System.Security.Cryptography.X509Certificates.X509Certificate2 $certTempFile

	$store = New-Object System.Security.Cryptography.X509Certificates.X509Store "Root", "LocalMachine"
	$store.Open([System.Security.Cryptography.X509Certificates.OpenFlags]::ReadWrite)
	$store.Add($CertToImport)
	$store.Close()
	
	Remove-Item $certTempFile
}
